#!/bin/bash
set -e

#Enable Debugging
set -x

mkdir /tmp/puppet

if [ -d /etc/puppetlabs/puppet/devices ]; then
cp -r /etc/puppetlabs/puppet/devices /tmp/puppet
chmod -R 775 /tmp/puppet/devices
else
mkdir /tmp/puppet/devices
fi

mkdir /tmp/puppet/pe-puppet
chmod -R 775 /tmp/puppet/pe-puppet

cp -r /etc/puppetlabs/puppet/manifests /tmp/puppet
cp -r /var/lib/puppet /tmp/puppet

cp -pr /var/opt/lib/pe-puppet/devices /tmp/puppet/pe-puppet
cp -pr /var/opt/lib/pe-puppet/reports /tmp/puppet/pe-puppet
cp -pr /var/opt/lib/pe-puppet/yaml /tmp/puppet/pe-puppet
cp -pr /var/opt/lib/pe-puppet/ssl /tmp/puppet/pe-puppet

# Backup Carbon Data to the pe-puppet directory for backup
cp -pr /var/lib/carbon /tmp/puppet/pe-puppet
# Backup ntp client settings
cp -pr /etc/ntp.conf /tmp/puppet/pe-puppet
cp -pr /etc/ntp/step-tickers /tmp/puppet/pe-puppet
# Backup TimeZone info
cp -pr /etc/sysconfig/clock /tmp/puppet/pe-puppet

cd /tmp/puppet/pe-puppet
tar cfp /tmp/puppet/pe-puppet.tar *


# Temp Debug to view pe-puppet.tar file contents
# cp /tmp/puppet/pe-puppet.tar ~/pe-puppet.tar
rm -rf /tmp/puppet/pe-puppet

cp -pr /opt/Dell/ASM/device /tmp/puppet
cp -pr /opt/Dell/ASM/deployments /tmp/puppet

cd /tmp/puppet/deployments
if [ "$(ls -A .)" ]; then
   tar cfp /tmp/puppet/deployments.tar *
fi

rm -rf /tmp/puppet/deployments

exit 0
